/*
 * extern.h
 *
 *
 */

#define EXTERN extern
EXTERN char infilename        [FILENAMELENGTH];
EXTERN char outfilename       [FILENAMELENGTH];
EXTERN char outtreename       [FILENAMELENGTH];
EXTERN char intreename        [FILENAMELENGTH];
EXTERN char outdistname       [FILENAMELENGTH];
EXTERN char outlmname         [FILENAMELENGTH];
EXTERN char outqlistname      [FILENAMELENGTH];
EXTERN char outallquartname   [FILENAMELENGTH];
EXTERN char outallquartlhname [FILENAMELENGTH];
EXTERN char outsitelhname     [FILENAMELENGTH];
EXTERN char outsitelhbname    [FILENAMELENGTH];
EXTERN char outsiteratename   [FILENAMELENGTH];
EXTERN char outsiteratebname  [FILENAMELENGTH];
EXTERN char outparamname      [FILENAMELENGTH];
EXTERN char insubsetmatrname  [FILENAMELENGTH];
EXTERN char outpstepname      [FILENAMELENGTH];
EXTERN char outptordername    [FILENAMELENGTH];
EXTERN char fileprefixname     [FILENAMELENGTH];



/* variables */
EXTERN cmatrix Seqchars;     /* characters contained in data set */
EXTERN ivector Seqgapchar;   /* counter for gaps contained in sequence */
EXTERN ivector Seqotherchar; /* counter for ambiguous contained in sequence */
EXTERN cmatrix treepict;     /* picture of consensus tree */
EXTERN double minscore;      /* value of edgescore on minedge */
EXTERN double tstvf84;       /* F84 transition/transversion ratio */
EXTERN double tstvratio;     /* expected transition/transversion ratio */
EXTERN double yrtsratio;     /* expected pyrimidine/purine transition ratio */
EXTERN dvector ulkl;         /* log L of user trees */
EXTERN dmatrix allsites;     /* log L per sites of utrees (numutrees,Numptrn) */
EXTERN dvector ulklc;        /* log L of utrees (clock) (numutrees,Numptrn) */
EXTERN dmatrix allsitesc;    /* log L per sites of user trees (clock) */
EXTERN FILE *utfp;           /* pointer to user tree file */
EXTERN FILE *ofp;            /* pointer to output file */
EXTERN FILE *seqfp;          /* pointer to sequence input file */
EXTERN FILE *tfp;            /* pointer to tree file */
EXTERN FILE *dfp;            /* pointer to distance file */
EXTERN FILE *trifp;          /* pointer to triangle file */
EXTERN FILE *unresfp;        /* pointer to file with unresolved quartets */
EXTERN FILE *tmpfp;          /* pointer to temporary file */
EXTERN FILE *qptlist;        /* pointer to file with puzzling step trees */
EXTERN FILE *qptorder;       /* pointer to file with unique puzzling step trees */
EXTERN int SHcodon;          /* whether SH should be applied to 1st, 2nd codon positions */
EXTERN int utree_optn;       /* use first user tree for estimation */
EXTERN int listqptrees;      /* list puzzling step trees */
EXTERN int approxqp;         /* approximate QP quartets */

EXTERN int codon_optn;       /* declares what positions in a codon should be used */
EXTERN int compclock;        /* computation of clocklike branch lengths */
EXTERN int chooseA;          /* leaf variable */
EXTERN int chooseB;          /* leaf variable */
EXTERN int clustA, clustB, clustC, clustD; /* number of members of LM clusters */

EXTERN int Frequ_optn;       /* use empirical base frequencies */

/* PSTEP_ORIG_H */
EXTERN int Maxbrnch;         /* 2*Maxspc - 3 */

EXTERN int Maxseqc;          /* number of sequence characters per taxum */
EXTERN int mflag;            /* flag used for correct printing of runtime messages */

EXTERN int numclust;         /* number of clusters in LM analysis */
EXTERN int outgroup;         /* outgroup */
EXTERN int puzzlemode;       /* computation of QP tree and/or ML distances */
EXTERN int rootsearch;       /* how location of root is found */
EXTERN int rhetmode;         /* model of rate heterogeneity */
EXTERN int seqnumcheck;      /* result of sequence number checkheterogeneity  */
EXTERN int usebestq_optn;    /* use only best quartet topology, no bayesian weights */
EXTERN int printrmatr_optn;  /* print rate matrix to screen */
EXTERN int usebranch_optn;   /* use branch lengths given in usertree */
EXTERN int show_optn;        /* show unresolved quartets    */
EXTERN int savequart_optn;   /* save memory block which quartets to file */
EXTERN int savequartlh_optn; /* save quartet likelihoods to file */
EXTERN int saveqlhbin_optn;  /* save quartet likelihoods binary */
EXTERN int savesitelh_optn;  /* save site likelihoods (PHILIP-like) */
EXTERN int savesitelhb_optn; /* save site likelihoods (binary) */
EXTERN int savesiterate_optn;  /* save site rates (PHILIP-like) */
EXTERN int savesiterateb_optn; /* save site rates (binary) */
EXTERN int readquart_optn;   /* read memory block which quartets from file */
EXTERN int fixedorder_optn;  /* use fixed puzzling insert order 1,2,3,...n */
EXTERN int conssub50_optn;   /* do  consensus down to percentage of first incongruence/ambiguity */
EXTERN int qsupport_optn;    /* compute quartet support for the splits */
EXTERN int dotreetest_optn;  /* compute tree statistics (ELW, KH, SH) */
EXTERN int dotreelh_optn;    /* compute lh/branch lengths (QP,consensus) */
EXTERN int setprefix_optn;   /* use other FILEPREFIX that INFILENAME */
EXTERN int consensus_optn;   /* do consensus tree instead of user trees */
EXTERN int sym_optn;         /* symmetrize doublet frequencies */
EXTERN int ytaxcounter;      /* counter for establishing y-coordinates of all taxa */
EXTERN int numutrees;        /* number of users trees in input tree file */
EXTERN ivector clusterA, clusterB, clusterC, clusterD;  /* clusters for LM analysis */

EXTERN ivector ycortax;      /* y-coordinates of all taxa */

EXTERN uli badqs;            /* number of bad quartets */
EXTERN uli unresqs;          /* number of unresolved quartets, formerly badqs */
EXTERN uli partresqs;        /* number of partly resolved quartets */
EXTERN uli fullresqs;        /* number of fully resolved quartets */
EXTERN uli missingqs;        /* number of fully resolved quartets */
EXTERN ulivector badtaxon;   /* involment of each taxon in a bad quartet */
EXTERN ulimatrix qinfomatr;  /* sums of quartet topologies per taxon [0]=sum */
EXTERN uli Currtrial;        /* counter for puzzling steps */

EXTERN uli Numquartets;      /* number of quartets */
EXTERN uli Numtrial;         /* number of puzzling steps */
EXTERN uli lmqts;            /* quartets investigated in LM analysis (0 = ALL) */

EXTERN int auto_datatype;       /* guess datatype ? */
EXTERN int guessdata_optn;      /* guessed datatype */

EXTERN int auto_aamodel;        /* guess amino acid modell ? */
EXTERN int guessauto_aamodel;   /* guessed amino acid modell ? */
EXTERN int guessDayhf_optn;     /* guessed Dayhoff model option */
EXTERN int guessJtt_optn;       /* guessed JTT model option */
EXTERN int guessblosum62_optn;  /* guessed BLOSUM 62 model option */
EXTERN int guessmtrev_optn;     /* guessed mtREV model option */
EXTERN int guesscprev_optn;     /* guessed cpREV model option */
EXTERN int guessvtmv_optn;      /* guessed VT model option */
EXTERN int guesswag_optn;       /* guessed WAG model option */

/* missing data: for handling subsets */
EXTERN int     readsubset_optn;           /* guessed WAG model option */
EXTERN int     Maxsubset;                 /* number of subsets */
EXTERN imatrix ss_setovlgraph;            /* size of overlap >= 3 between 2 subsets */
EXTERN imatrix ss_setoverlaps;            /* size of overlap between 2 subsets */
EXTERN imatrix ss_setovllist;             /* list with ovlerlapping subsets */
EXTERN ivector ss_setovllistsize;         /* size of list with ovlerlapping subsets */
EXTERN imatrix ss_matrix;                 /* boolean list: taxon in set? */
EXTERN imatrix ss_list;                   /* list of taxa in set */
EXTERN ivector ss_listsize;                /* size of list with taxa */

/* counter variables needed in likelihood mapping analysis */
EXTERN uli ar1, ar2, ar3;
EXTERN uli reg1, reg2, reg3, reg4, reg5, reg6, reg7;
EXTERN uli reg1l, reg1r, reg2u, reg2d, reg3u, reg3d,
 reg4u, reg4d, reg5l, reg5r, reg6u, reg6d;
EXTERN unsigned char *quartetinfo; /* place where quartets are stored */
EXTERN dvector qweight; /* for use in QP and LM analysis */
EXTERN dvector sqdiff;
EXTERN ivector qworder;
EXTERN ivector sqorder;

EXTERN int randseed;
EXTERN int psteptreestrlen;

EXTERN double cputime, walltime;
EXTERN double fullcpu, fulltime;
EXTERN double fullcputime, fullwalltime;
EXTERN double altcputime, altwalltime;
EXTERN clock_t cputimestart,  cputimestop, cputimedummy;
EXTERN time_t  walltimestart, walltimestop, walltimedummy;
EXTERN clock_t Startcpu;     /* start cpu time */
EXTERN clock_t Stopcpu;      /* stop cpu time */
EXTERN time_t MLstepStarttime;     /* start time */
EXTERN time_t MLstepStoptime;      /* stop time */
EXTERN time_t PStepStarttime;     /* start time */
EXTERN time_t PStepStoptime;      /* stop time */
EXTERN time_t PEstStarttime;     /* start time */
EXTERN time_t PEstStoptime;      /* stop time */
EXTERN time_t Starttime;     /* start time */
EXTERN time_t Stoptime;      /* stop time */
EXTERN time_t time0;         /* timer variable */
EXTERN time_t time1;         /* yet another timer */
EXTERN time_t time2;         /* yet another timer */
EXTERN timearray_t tarr;
