/*
 * vars.h
 *
 *
 */

 char INFILE        [FILENAMELENGTH];
 char OUTFILE       [FILENAMELENGTH];
 char TREEFILE       [FILENAMELENGTH];
 char TEMPFILE       [FILENAMELENGTH];
 char INTREE[FILENAMELENGTH];
 char DISTANCES       [FILENAMELENGTH];
 char TRIANGLE         [FILENAMELENGTH];
 char UNRESOLVED      [FILENAMELENGTH];
 char ALLQUART   [FILENAMELENGTH];
 char ALLQUARTLH [FILENAMELENGTH];
 char SITELH     [FILENAMELENGTH];
 char SITELHB    [FILENAMELENGTH];
 char SITERATE   [FILENAMELENGTH];
 char SITERATEB  [FILENAMELENGTH];
 char OUTPARAM      [FILENAMELENGTH];
 char SUBSET  [FILENAMELENGTH];
 char OUTPTLIST      [FILENAMELENGTH];
 char OUTPTORDER    [FILENAMELENGTH];

 char FILEPREFIX     [FILENAMELENGTH];


/* variables */
 cmatrix Seqchars;     /* characters contained in data set */
 ivector Seqgapchar;   /* counter for gaps contained in sequence */
 ivector Seqotherchar; /* counter for ambiguous contained in sequence */
 cmatrix treepict;     /* picture of consensus tree */
 double minscore;      /* value of edgescore on minedge */
 double tstvf84;       /* F84 transition/transversion ratio */
 double tstvratio;     /* expected transition/transversion ratio */
 double yrtsratio;     /* expected pyrimidine/purine transition ratio */
 dvector ulkl;         /* log L of user trees */
 dmatrix allsites;     /* log L per sites of utrees (numutrees,Numptrn) */
 dvector ulklc;        /* log L of utrees (clock) (numutrees,Numptrn) */
 dmatrix allsitesc;    /* log L per sites of user trees (clock) */
 FILE *utfp;           /* pointer to user tree file */
 FILE *ofp;            /* pointer to output file */
 FILE *seqfp;          /* pointer to sequence input file */
 FILE *tfp;            /* pointer to tree file */
 FILE *dfp;            /* pointer to distance file */
 FILE *trifp;          /* pointer to triangle file */
 FILE *unresfp;        /* pointer to file with unresolved quartets */
 FILE *tmpfp;          /* pointer to temporary file */
 FILE *qptlist;        /* pointer to file with puzzling step trees */
 FILE *qptorder;       /* pointer to file with unique puzzling step trees */
 int SHcodon;          /* whether SH should be applied to 1st, 2nd codon positions */
 int utree_optn;       /* use first user tree for estimation */
 int listqptrees;      /* list puzzling step trees */
 int approxqp;         /* approximate QP quartets */

 int codon_optn;       /* declares what positions in a codon should be used */
 int compclock;        /* computation of clocklike branch lengths */
 int chooseA;          /* leaf variable */
 int chooseB;          /* leaf variable */
 int clustA, clustB, clustC, clustD; /* number of members of LM clusters */

 int Frequ_optn;       /* use empirical base frequencies */

/* PSTEP_ORIG_H */
 int Maxbrnch;         /* 2*Maxspc - 3 */

 int Maxseqc;          /* number of sequence characters per taxum */
 int mflag;            /* flag used for correct printing of runtime messages */

 int numclust;         /* number of clusters in LM analysis */
 int outgroup;         /* outgroup */
 int puzzlemode;       /* computation of QP tree and/or ML distances */
 int rootsearch;       /* how location of root is found */
 int rhetmode;         /* model of rate heterogeneity */
 int seqnumcheck;      /* result of sequence number checkheterogeneity  */
 int usebestq_optn;    /* use only best quartet topology, no bayesian weights */
 int printrmatr_optn;  /* print rate matrix to screen */
 int usebranch_optn;   /* use branch lengths given in usertree */
 int show_optn;        /* show unresolved quartets    */
 int savequart_optn;   /* save memory block which quartets to file */
 int savequartlh_optn; /* save quartet likelihoods to file */
 int saveqlhbin_optn;  /* save quartet likelihoods binary */
 int savesitelh_optn;  /* save site likelihoods (PHILIP-like) */
 int savesitelhb_optn; /* save site likelihoods (binary) */
 int savesiterate_optn;  /* save site rates (PHILIP-like) */
 int savesiterateb_optn; /* save site rates (binary) */
 int readquart_optn;   /* read memory block which quartets from file */
 int fixedorder_optn;  /* use fixed puzzling insert order 1,2,3,...n */
 int conssub50_optn;   /* do  consensus down to percentage of first incongruence/ambiguity */
 int qsupport_optn;    /* compute quartet support for the splits */
 int dotreetest_optn;  /* compute tree statistics (ELW, KH, SH) */
 int dotreelh_optn;    /* compute lh/branch lengths (QP,consensus) */
 int setprefix_optn;   /* use other FILEPREFIX that INFILENAME */
 int consensus_optn;   /* do consensus tree instead of user trees */
 int sym_optn;         /* symmetrize doublet frequencies */
 int ytaxcounter;      /* counter for establishing y-coordinates of all taxa */
 int numutrees;        /* number of users trees in input tree file */
 ivector clusterA, clusterB, clusterC, clusterD;  /* clusters for LM analysis */

 ivector ycortax;      /* y-coordinates of all taxa */

 uli badqs;            /* number of bad quartets */
 uli unresqs;          /* number of unresolved quartets, formerly badqs */
 uli partresqs;        /* number of partly resolved quartets */
 uli fullresqs;        /* number of fully resolved quartets */
 uli missingqs;        /* number of fully resolved quartets */
 ulivector badtaxon;   /* involment of each taxon in a bad quartet */
 ulimatrix qinfomatr;  /* sums of quartet topologies per taxon [0]=sum */
 uli Currtrial;        /* counter for puzzling steps */

 uli Numquartets;      /* number of quartets */
 uli Numtrial;         /* number of puzzling steps */
 uli lmqts;            /* quartets investigated in LM analysis (0 = ALL) */

 int auto_datatype;       /* guess datatype ? */
 int guessdata_optn;      /* guessed datatype */

 int auto_aamodel;        /* guess amino acid modell ? */
 int guessauto_aamodel;   /* guessed amino acid modell ? */
 int guessDayhf_optn;     /* guessed Dayhoff model option */
 int guessJtt_optn;       /* guessed JTT model option */
 int guessblosum62_optn;  /* guessed BLOSUM 62 model option */
 int guessmtrev_optn;     /* guessed mtREV model option */
 int guesscprev_optn;     /* guessed cpREV model option */
 int guessvtmv_optn;      /* guessed VT model option */
 int guesswag_optn;       /* guessed WAG model option */

/* missing data: for handling subsets */
 int     readsubset_optn;           /* guessed WAG model option */
 int     Maxsubset;                 /* number of subsets */
 imatrix ss_setovlgraph;            /* size of overlap >= 3 between 2 subsets */
 imatrix ss_setoverlaps;            /* size of overlap between 2 subsets */
 imatrix ss_setovllist;             /* list with ovlerlapping subsets */
 ivector ss_setovllistsize;         /* size of list with ovlerlapping subsets */
 imatrix ss_matrix;                 /* boolean list: taxon in set? */
 imatrix ss_list;                   /* list of taxa in set */
 ivector ss_listsize;                /* size of list with taxa */

/* counter variables needed in likelihood mapping analysis */
 uli ar1, ar2, ar3;
 uli reg1, reg2, reg3, reg4, reg5, reg6, reg7;
 uli reg1l, reg1r, reg2u, reg2d, reg3u, reg3d,
 reg4u, reg4d, reg5l, reg5r, reg6u, reg6d;
 unsigned char *quartetinfo; /* place where quartets are stored */
 dvector qweight; /* for use in QP and LM analysis */
 dvector sqdiff;
 ivector qworder;
 ivector sqorder;

 int randseed;
 int psteptreestrlen;

 double cputime, walltime;
 double fullcpu, fulltime;
 double fullcputime, fullwalltime;
 double altcputime, altwalltime;
 clock_t cputimestart,  cputimestop, cputimedummy;
 time_t  walltimestart, walltimestop, walltimedummy;
 clock_t Startcpu;     /* start cpu time */
 clock_t Stopcpu;      /* stop cpu time */
 time_t MLstepStarttime;     /* start time */
 time_t MLstepStoptime;      /* stop time */
 time_t PStepStarttime;     /* start time */
 time_t PStepStoptime;      /* stop time */
 time_t PEstStarttime;     /* start time */
 time_t PEstStoptime;      /* stop time */
 time_t Starttime;     /* start time */
 time_t Stoptime;      /* stop time */
 time_t time0;         /* timer variable */
 time_t time1;         /* yet another timer */
 time_t time2;         /* yet another timer */
 timearray_t tarr;

